'use strict';

angular.module('adf.widget.electre.lavoisier')
        .service('lavoisierHttpRequestService', 
            [
                "$http", "$q",
                function ($http, $q) {
                    /**
                     * Used as valid parameters for the http request.
                     * @type Object
                     */
                    var validParams = {};
                    /**
                     * 
                     * @param {Object} params Containing information about the url to pass to the $http service.
                     */
                    function recupUrl (params) {
                        // Détection du '?' dans l'url
                        if (params.url.match(/\u003f/) && params.params) {
                            // Récupération distincte de l'url avant et après le ?
                            validParams.url = params.url.substring(0, params.url.search(/\u003f/));
                            validParams.params = {};
                            
                            // Récupération de la chaine de paramètre.
                            var parametres = params.url.substring(params.url.search(/\u003f/) + 1);
                            
                            // Si la chaine de paramètre contient un '&'
                            if (parametres.indexOf("&") !== -1) {
                                parametres = parametres.split("&");
                                for (var i = 0 ; i < parametres.length ; i++) parametres[i] = parametres[i].split("=");
                            } else {
                                parametres = [parametres.split("=")];
                            }
                            
                            // Récupération de la liste des paramètres.
                            for (var i = 0 ; i < parametres.length ; i++) validParams.params[parametres[i][0]] = parametres[i][1];
                            
                            for (var index in params.params) validParams.params[index] = params.params[index];
                        } else {
                            validParams.url = params.url;
                            validParams.params = params.params;
                        }
                    }
                    
                    return {
                        /**
                         * Call to $http service with validate parameters.
                         * @param {Object} params
                         * @returns {$q@call;defer.promise}
                         */
                        getResult : function (params) {
                            var deferred = $q.defer();
                            recupUrl(params);
                            
                            $http(
                                {
                                    url : validParams.url,
                                    params : (validParams.params ? validParams.params : {})
                                }
                            ).success(
                                function (data) {
                                    deferred.resolve(data);
                                }
                            ).error(
                                function (data) {
                                    deferred.reject();
                                }
                            );
                            
                            return deferred.promise;
                        },
                        /**
                         * Call to $http service without validated parameters.
                         * @param {Object} params
                         * @returns {$q@call;defer.promise}
                         */
                        getResult_2 : function (params) {
                            var deferred = $q.defer();

                            $http.defaults.transformResponse = [];
                            $http.defaults.transformResponse.unshift(function(value) { return value; });
                            /*if (params.transformResponse) {
                                $http.defaults.transformResponse = [];
                                $http.defaults.transformResponse.unshift(params.transformResponse);
                            }*/

                            $http(
                                {
                                    url : params.url,
                                    params : (params.params ? params.params : {})
                                }
                            ).success(
                                function (data) {
                                    deferred.resolve(data);
                                }
                            ).error(
                                function (data) {
                                    deferred.reject();
                                }
                            );
                            
                            return deferred.promise;
                        }
                    };
                }
            ]
        );